// Generated by gencpp from file mbf_msgs/FindValidPoseRequest.msg
// DO NOT EDIT!


#ifndef MBF_MSGS_MESSAGE_FINDVALIDPOSEREQUEST_H
#define MBF_MSGS_MESSAGE_FINDVALIDPOSEREQUEST_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/PoseStamped.h>

namespace mbf_msgs
{
template <class ContainerAllocator>
struct FindValidPoseRequest_
{
  typedef FindValidPoseRequest_<ContainerAllocator> Type;

  FindValidPoseRequest_()
    : pose()
    , safety_dist(0.0)
    , dist_tolerance(0.0)
    , angle_tolerance(0.0)
    , costmap(0)
    , current_pose(false)
    , use_padded_fp(false)  {
    }
  FindValidPoseRequest_(const ContainerAllocator& _alloc)
    : pose(_alloc)
    , safety_dist(0.0)
    , dist_tolerance(0.0)
    , angle_tolerance(0.0)
    , costmap(0)
    , current_pose(false)
    , use_padded_fp(false)  {
  (void)_alloc;
    }



   typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef float _safety_dist_type;
  _safety_dist_type safety_dist;

   typedef float _dist_tolerance_type;
  _dist_tolerance_type dist_tolerance;

   typedef float _angle_tolerance_type;
  _angle_tolerance_type angle_tolerance;

   typedef uint8_t _costmap_type;
  _costmap_type costmap;

   typedef uint8_t _current_pose_type;
  _current_pose_type current_pose;

   typedef uint8_t _use_padded_fp_type;
  _use_padded_fp_type use_padded_fp;



// reducing the odds to have name collisions with Windows.h 
#if defined(_WIN32) && defined(LOCAL_COSTMAP)
  #undef LOCAL_COSTMAP
#endif
#if defined(_WIN32) && defined(GLOBAL_COSTMAP)
  #undef GLOBAL_COSTMAP
#endif

  enum {
    LOCAL_COSTMAP = 1u,
    GLOBAL_COSTMAP = 2u,
  };


  typedef boost::shared_ptr< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> const> ConstPtr;

}; // struct FindValidPoseRequest_

typedef ::mbf_msgs::FindValidPoseRequest_<std::allocator<void> > FindValidPoseRequest;

typedef boost::shared_ptr< ::mbf_msgs::FindValidPoseRequest > FindValidPoseRequestPtr;
typedef boost::shared_ptr< ::mbf_msgs::FindValidPoseRequest const> FindValidPoseRequestConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator1> & lhs, const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator2> & rhs)
{
  return lhs.pose == rhs.pose &&
    lhs.safety_dist == rhs.safety_dist &&
    lhs.dist_tolerance == rhs.dist_tolerance &&
    lhs.angle_tolerance == rhs.angle_tolerance &&
    lhs.costmap == rhs.costmap &&
    lhs.current_pose == rhs.current_pose &&
    lhs.use_padded_fp == rhs.use_padded_fp;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator1> & lhs, const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace mbf_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e0c36428252e9af85363d919831f88be";
  }

  static const char* value(const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe0c36428252e9af8ULL;
  static const uint64_t static_value2 = 0x5363d919831f88beULL;
};

template<class ContainerAllocator>
struct DataType< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mbf_msgs/FindValidPoseRequest";
  }

  static const char* value(const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Find the closest free pose to the given one, within the given linear and angular tolerances.\n"
"#\n"
"# A pose is considered free if the robot footprint there is entirely inside the map and neither in\n"
"# collision nor unknown space.\n"
"#\n"
"# If no free pose can be found, but we find one partially in unknown space, or partially outside the map,\n"
"# we will return it and set state to the corresponding option (unknown space takes precedence).\n"
"# Otherwise state will be set to LETHAL.\n"
"#\n"
"# You can also instruct this service to use current robot's pose, instead of providing one.\n"
"\n"
"uint8                      LOCAL_COSTMAP  = 1\n"
"uint8                      GLOBAL_COSTMAP = 2\n"
"\n"
"geometry_msgs/PoseStamped  pose              # the starting pose from which we start the search\n"
"float32                    safety_dist       # minimum distance allowed to the closest obstacle\n"
"float32                    dist_tolerance    # maximum distance we can deviate from the given pose during the search\n"
"float32                    angle_tolerance   # maximum angle we can rotate the given pose during the search\n"
"uint8                      costmap           # costmap in which to check the pose\n"
"bool                       current_pose      # check current robot pose instead (ignores pose field)\n"
"bool                       use_padded_fp     # include footprint padding when checking cost; note that safety distance\n"
"                                             # will be measured from the padded footprint\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/PoseStamped\n"
"# A Pose with reference coordinate frame and timestamp\n"
"Header header\n"
"Pose pose\n"
"\n"
"================================================================================\n"
"MSG: std_msgs/Header\n"
"# Standard metadata for higher-level stamped data types.\n"
"# This is generally used to communicate timestamped data \n"
"# in a particular coordinate frame.\n"
"# \n"
"# sequence ID: consecutively increasing ID \n"
"uint32 seq\n"
"#Two-integer timestamp that is expressed as:\n"
"# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n"
"# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n"
"# time-handling sugar is provided by the client library\n"
"time stamp\n"
"#Frame this data is associated with\n"
"string frame_id\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Pose\n"
"# A representation of pose in free space, composed of position and orientation. \n"
"Point position\n"
"Quaternion orientation\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Quaternion\n"
"# This represents an orientation in free space in quaternion form.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"float64 w\n"
;
  }

  static const char* value(const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pose);
      stream.next(m.safety_dist);
      stream.next(m.dist_tolerance);
      stream.next(m.angle_tolerance);
      stream.next(m.costmap);
      stream.next(m.current_pose);
      stream.next(m.use_padded_fp);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct FindValidPoseRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mbf_msgs::FindValidPoseRequest_<ContainerAllocator>& v)
  {
    if (false || !indent.empty())
      s << std::endl;
    s << indent << "pose: ";
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "safety_dist: ";
    Printer<float>::stream(s, indent + "  ", v.safety_dist);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "dist_tolerance: ";
    Printer<float>::stream(s, indent + "  ", v.dist_tolerance);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "angle_tolerance: ";
    Printer<float>::stream(s, indent + "  ", v.angle_tolerance);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "costmap: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.costmap);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "current_pose: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.current_pose);
    if (true || !indent.empty())
      s << std::endl;
    s << indent << "use_padded_fp: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_padded_fp);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MBF_MSGS_MESSAGE_FINDVALIDPOSEREQUEST_H
